﻿from multiprocessing import Process
from SimpleHTTPServer import SimpleHTTPRequestHandler
import BaseHTTPServer
import socket

IP = ""
if IP == "":
    IP = socket.gethostbyname(socket.gethostname())
print "IP: ", IP

OPDS_XML = '''<?xml version="1.0" encoding="utf-8"?>
<feed xmlns:opds="http://opds-spec.org/2010/catalog" xmlns:opensearch="http://a9.com/-/spec/opensearch/1.1/" xmlns:dcterms="http://purl.org/dc/terms/" xmlns:thr="http://purl.org/syndication/thread/1.0" xmlns:dc="http://dublincore.org/documents/dcmi-namespace/" xmlns="http://www.w3.org/2005/Atom">
  <title type="text">锦书OPDS源列表</title>
  <id>uuid:ea8a979d-7e28-4bf7-8d11-31aafb2ac66a;id=60</id>
  <updated>2012-03-11T15:49:25Z</updated>
  <link rel="search" type="application/atom+xml" href="http://opds.gk.sdo.com/Search.aspx?ST=ALL&amp;PageIndex=1&amp;k={searchTerms}&amp;{bbtk}" />
  <entry>
    <id>JiuYue</id>
    <title type="text">新华书店九月网</title>
    <updated>2012-03-11T15:49:25Z</updated>
    <link rel="alternate" type="application/atom+xml" href="http://opds.9yue.com/category.atom?site=BamBook" />
    <content type="text">新华书店九月网</content>
  </entry>
  <entry>
    <id>http://m.gutenberg.org/ebooks/?format=opds</id>
    <title type="text">古腾堡计划</title>
    <updated>2012-03-11T15:49:25Z</updated>
    <link rel="alternate" type="application/atom+xml" href="http://m.gutenberg.org/ebooks/?format=opds" />
    <content type="text">英文电子书</content>
  </entry>
  <entry>
    <id>http://www.feedbooks.com/site/free_books.atom</id>
    <title type="text">feedbooks</title>
    <updated>2012-03-11T15:49:25Z</updated>
    <link rel="alternate" type="application/atom+xml" href="http://www.feedbooks.com/site/free_books.atom" />
    <content type="text">在线阅读网线图书</content>
  </entry>
  <entry>
    <id>http://www.feedbooks.com/site/free_books.atom</id>
    <title type="text">calibre</title>
    <updated>2012-03-11T15:49:25Z</updated>
    <link rel="alternate" type="application/atom+xml" href="http://''' + IP + ''':8080/opds" />
    <content type="text">calibre</content>
  </entry>
</feed>
'''

class BambookHTTPRequestHandler(SimpleHTTPRequestHandler):
    def __init__(self, req, client_addr, server):
        SimpleHTTPRequestHandler.__init__(self, req, client_addr, server)

    def do_GET(self):
        self.send_response(200)
        self.send_header("Content-type", "text/xml")
        self.send_header("Content-length", len(OPDS_XML))
        self.end_headers()
        self.wfile.write(OPDS_XML)

if __name__ == "__main__":     
    PORT = 80
    httpd = BaseHTTPServer.HTTPServer(("", PORT), BambookHTTPRequestHandler)
    print "Start HTTP Server at Port ", PORT
    httpd.serve_forever()

